package com.ytpm.middle.dao;

import com.ytpm.middle.model.YtFinancePayment;
import com.ytpm.middle.model.YtFinancePaymentItem;
import com.ytpm.middle.model.YtFinancePaymentRecord;
import com.ytpm.middle.param.PaymentItemParam;
import com.ytpm.middle.param.PaymentListParam;
import com.ytpm.middle.view.FinancePaymentItemVO;
import com.ytpm.middle.view.FinancePaymentVO;
import com.ytpm.middle.view.PaymentItemVO;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

@Mapper
public interface FinanceMapper {
    /**
     * 查询缴费项目列表
     */
    List<PaymentItemVO> queryList(PaymentItemParam param);

    /**
     * 新增缴费项目
     */
    void addItem(YtFinancePaymentItem item);

    /**
     * 修改缴费项目
     */
    void updateItem(YtFinancePaymentItem item);

    /**
     * 查询缴费项目
     */
    YtFinancePaymentItem selectItemOne(@Param("itemId") String itemId);

    /**
     * 新增缴费记录
     */
    void addPaymentRecord(YtFinancePaymentRecord record);

    /**
     * 新增缴费单
     */
    void addPayment(YtFinancePayment payment);
    /**
     * 修改缴费单
     */
    void updatePayment(YtFinancePayment payment);

    /**
     * 查询缴费单列表
     */
    List<FinancePaymentVO> paymentList(PaymentListParam param);

    /**
     * 查询缴费单详情
     */
    FinancePaymentVO getPaymentDetail(@Param("paymentId") String paymentId);

    /**
     * 修改缴费记录
     */
    void updatePaymentRecord(@Param("paymentId")String paymentId);

    /**
     * 根据缴费单类型查询企业用户缴费信息
     */
    FinancePaymentVO getPaymentByType(@Param("userId") String userId, @Param("type")int type);

    /**
     * 根据缴费项目ID查询缴费项目
     */
    List<FinancePaymentItemVO> findByItemIds(@Param("itemIdList") List<String> itemIdList);
}
